﻿namespace SetlistBuilder
{
    public class Program
    {
        public static void Main(string[] args)
        {
            var options = new Queue<string>(args);
            bool singlePage = false;
            string inputPath = null;
            string outputPath = null;

            while (options.TryDequeue(out string option))
            {
                switch (option)
                {
                    case "-s":
                        singlePage = true;
                        break;
                    case "-m":
                        singlePage = false;
                        break;
                    case "-i":
                        if (options.TryDequeue(out inputPath) == false)
                            throw new Exception("No input path provided");
                        if (!Directory.Exists(inputPath))
                            throw new Exception($"Input path {inputPath} is not a valid path");
                        break;
                    case "-o":
                        if (options.TryDequeue(out outputPath) == false)
                            throw new Exception("No output path provided");
                        break;
                    default:
                        throw new Exception($"Invalid option {option}");
                }
            }

            if (inputPath == null) throw new Exception("Input path not provided");
            if (singlePage)  new SinglePageBuilder("manifest.json", inputPath).Build();
            else new MultiPageBuilder("manifest.json", inputPath).Build(outputPath ?? throw new Exception("outputPath not provided"));
        }
    }
}